p8086
model small
codeseg
startupcode

mov al, 013h
mov ah, 0
int 10h

mov boundtop, word ptr 0
mov boundleft, word ptr 0
mov boundright, word ptr 320
mov boundbottom, word ptr 200

mov xdirection, word ptr 1
mov ydirection, word ptr 1

mov xposstart, word ptr 12
mov yposstart, word ptr 12
mov iposcount, word ptr 5

again:
mov ax, SEG sprites
mov es, ax
mov ax, OFFSET sprites
mov di, ax

mov ax, xposstart
mov xpos, ax
mov ax, yposstart
mov ypos, ax

againsub:
mov ax, xpos
mov cx, ax
mov ax, ypos
mov dx, ax
mov al, byte ptr es:[di]
inc di
mov ah, 0ch
int 10h

mov ax, xpos
inc ax
mov xpos, ax

mov bx, xposstart
clc
adc bx, iposcount

cmp ax, bx
jl againsub

mov ax, xposstart
mov xpos, ax

mov ax, ypos
inc ax
mov ypos, ax

mov bx, yposstart
clc
adc bx, iposcount

cmp ax, bx
jl againsub

call movsprite

;mov ah, 0
mov ah, 1
int 16h
jnz exitroutine
jmp again

exitroutine:;
mov al, 03
mov ah, 0
int 10h

mov ah, 04ch
int 21h

movsprite:
push ax
push bx
push cx
push dx
push ds
push si
push es
push di

mov ax, ydirection
cmp ax, word ptr 0
je movup
cmp ax, word ptr 1
je movdown
jmp checkxdirection

movup:
mov ax, yposstart
cmp ax, boundtop
je maxedboundtop
dec ax
mov yposstart, ax
jmp checkxdirection

maxedboundtop:
mov ydirection, word ptr 1
jmp checkxdirection

movdown:
mov ax, yposstart
mov bx, boundbottom
clc
sbb bx, iposcount
cmp ax, bx
je maxedboundbottom
inc ax
mov yposstart, ax
jmp checkxdirection

maxedboundbottom:
mov ydirection, word ptr 0
jmp checkxdirection



checkxdirection:

mov ax, xdirection
cmp ax, word ptr 0
je movleft
cmp ax, word ptr 1
je movright
jmp exitmovsprite

movright:
mov ax, xposstart
mov bx, boundright
clc
sbb bx, iposcount
cmp ax, bx
je maxedboundright
inc ax
mov xposstart, ax
jmp exitmovsprite

maxedboundright:
mov xdirection, word ptr 0
jmp exitmovsprite

movleft:
mov ax, xposstart
cmp ax, boundleft
je maxedboundleft
dec ax
mov xposstart, ax
jmp exitmovsprite

maxedboundleft:
mov xdirection, word ptr 1
jmp exitmovsprite

exitmovsprite:
pop di
pop es
pop si
pop ds
pop dx
pop cx
pop bx
pop ax
ret

sprites:
DB 000,000,014,000,000
DB 014,014,014,014,014
DB 000,000,014,000,000
DB 000,000,014,000,000
DB 000,000,014,000,000

xposstart DW 0
yposstart DW 0
iposcount DW 0

xpos DW 0
ypos DW 0

xdirection DW 0
ydirection DW 0

boundtop    DW 0
boundleft   DW 0
boundright  DW 0
boundbottom DW 0

end